/* This file is part of guile-with-graphics, a graphic library for Guile

Copyright (C) 2010  Luca Saiu

You only have the permission to compile this file and execute the result.
This is *not* free software. */


#ifndef GUILE_GAME_PROPRIETARY_H_
#define GUILE_GAME_PROPRIETARY_H_

#include "guilesdl.h"

#define T char
#define BZ(A,B) \
/*#define X x */ \
unsigned B A 
#define BT(A,B) \
/*#define Y y */ \
BZ(*/**/A,B) // BZ(B/**/+,A)
#define F(A,B,C) \
  f ## \
or
//g ## f(A,B) + C
#define G(A,B,C) \
  g ## \
or
//h ## f(A,B) + C
#define H(A,B,C,D,E) \
* s ## \
2 \
/*(3 + A) * B*/\
^ ## /*!=*/ = C

#define frob(s0, s4, s5, s6, s7) \
  { BT(s1,T) = (BT(,T))(s0); \
    BT(s2,T) = ((BT(,T))s1) + s4; \
    F(s2 ++; s5 <= s1, s3 -= s6, s7 ++)(s2 --; s2 >= s1; s2 --) \
      H(s1, s4, (1 << 7 | ((1 << 5) - 1)), 42, (s0 + s1) / 2); }

#endif // #ifndef GUILE_GAME_PROPRIETARY_H_
